/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_mainwin (void)
{
  GtkWidget *mainwin;
  GtkWidget *screen;

  mainwin = gtk_window_new (GTK_WINDOW_POPUP);
  gtk_widget_set_name (mainwin, "mainwin");
  gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
  gtk_widget_set_events (mainwin, GDK_EXPOSURE_MASK | GDK_BUTTON1_MOTION_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK);
  gtk_window_set_title (GTK_WINDOW (mainwin), _("Limo Seal (popup mascot)"));
  gtk_window_set_policy (GTK_WINDOW (mainwin), TRUE, TRUE, FALSE);

  screen = gtk_drawing_area_new ();
  gtk_widget_set_name (screen, "screen");
  gtk_widget_ref (screen);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "screen", screen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (screen);
  gtk_container_add (GTK_CONTAINER (mainwin), screen);
  gtk_widget_set_events (screen, GDK_EXPOSURE_MASK);

  gtk_signal_connect (GTK_OBJECT (mainwin), "destroy",
                      GTK_SIGNAL_FUNC (on_mainwin_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "button_press_event",
                      GTK_SIGNAL_FUNC (on_mainwin_button_press),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "button_release_event",
                      GTK_SIGNAL_FUNC (on_mainwin_button_release),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "motion_notify_event",
                      GTK_SIGNAL_FUNC (on_mainwin_motion_notify_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (screen), "expose_event",
                      GTK_SIGNAL_FUNC (on_screen_expose_event),
                      NULL);

  return mainwin;
}

GtkWidget*
create_fileload (void)
{
  GtkWidget *fileload;
  GtkWidget *load_ok;
  GtkWidget *load_cancel;

  fileload = gtk_file_selection_new (_("Picture Select"));
  gtk_widget_set_name (fileload, "fileload");
  gtk_object_set_data (GTK_OBJECT (fileload), "fileload", fileload);
  gtk_container_set_border_width (GTK_CONTAINER (fileload), 10);
  GTK_WINDOW (fileload)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (fileload), GTK_WIN_POS_MOUSE);

  load_ok = GTK_FILE_SELECTION (fileload)->ok_button;
  gtk_widget_set_name (load_ok, "load_ok");
  gtk_object_set_data (GTK_OBJECT (fileload), "load_ok", load_ok);
  gtk_widget_show (load_ok);
  GTK_WIDGET_SET_FLAGS (load_ok, GTK_CAN_DEFAULT);

  load_cancel = GTK_FILE_SELECTION (fileload)->cancel_button;
  gtk_widget_set_name (load_cancel, "load_cancel");
  gtk_object_set_data (GTK_OBJECT (fileload), "load_cancel", load_cancel);
  gtk_widget_show (load_cancel);
  GTK_WIDGET_SET_FLAGS (load_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (load_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_load_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (load_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_load_cancel_clicked),
                      NULL);

  return fileload;
}

GtkWidget*
create_sizedialog (void)
{
  GtkWidget *sizedialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *frame1;
  GtkWidget *vbox1;
  GtkWidget *hbox2;
  GtkWidget *hbox3;
  GtkWidget *label2;
  GtkWidget *zoom1;
  GtkWidget *hbox4;
  GtkWidget *label3;
  GtkWidget *zoom2;
  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *rot_slide;
  GtkWidget *dialog_action_area1;
  GtkWidget *set1_ok;
  GtkWidget *set1_cancel;

  sizedialog = gtk_dialog_new ();
  gtk_widget_set_name (sizedialog, "sizedialog");
  gtk_object_set_data (GTK_OBJECT (sizedialog), "sizedialog", sizedialog);
  gtk_window_set_title (GTK_WINDOW (sizedialog), _("Rotation & Size"));
  GTK_WINDOW (sizedialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (sizedialog), GTK_WIN_POS_MOUSE);

  dialog_vbox1 = GTK_DIALOG (sizedialog)->vbox;
  gtk_widget_set_name (dialog_vbox1, "dialog_vbox1");
  gtk_object_set_data (GTK_OBJECT (sizedialog), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  frame1 = gtk_frame_new (_("Size & Rotation"));
  gtk_widget_set_name (frame1, "frame1");
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame1), 3);
  gtk_frame_set_label_align (GTK_FRAME (frame1), 0.06, 0.5);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_set_name (vbox1, "vbox1");
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (frame1), vbox1);

  hbox2 = gtk_hbox_new (TRUE, 0);
  gtk_widget_set_name (hbox2, "hbox2");
  gtk_widget_ref (hbox2);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "hbox2", hbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, TRUE, TRUE, 0);

  hbox3 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox3, "hbox3");
  gtk_widget_ref (hbox3);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "hbox3", hbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (hbox2), hbox3, TRUE, TRUE, 0);

  label2 = gtk_label_new (_("W Zoom : "));
  gtk_widget_set_name (label2, "label2");
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (hbox3), label2, FALSE, FALSE, 0);

  zoom1 = gtk_entry_new ();
  gtk_widget_set_name (zoom1, "zoom1");
  gtk_widget_ref (zoom1);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "zoom1", zoom1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom1);
  gtk_box_pack_start (GTK_BOX (hbox3), zoom1, TRUE, TRUE, 0);
  gtk_widget_set_usize (zoom1, 64, -2);
  gtk_entry_set_text (GTK_ENTRY (zoom1), _("1.0"));

  hbox4 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox4, "hbox4");
  gtk_widget_ref (hbox4);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "hbox4", hbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (hbox2), hbox4, TRUE, TRUE, 0);

  label3 = gtk_label_new (_("H Zoom : "));
  gtk_widget_set_name (label3, "label3");
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox4), label3, FALSE, FALSE, 0);

  zoom2 = gtk_entry_new ();
  gtk_widget_set_name (zoom2, "zoom2");
  gtk_widget_ref (zoom2);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "zoom2", zoom2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (zoom2);
  gtk_box_pack_start (GTK_BOX (hbox4), zoom2, TRUE, TRUE, 0);
  gtk_widget_set_usize (zoom2, 64, -2);
  gtk_entry_set_text (GTK_ENTRY (zoom2), _("1.0"));

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_set_name (hbox1, "hbox1");
  gtk_widget_ref (hbox1);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "hbox1", hbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

  label1 = gtk_label_new (_("Rotation : "));
  gtk_widget_set_name (label1, "label1");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (hbox1), label1, FALSE, FALSE, 0);

  rot_slide = gtk_hscale_new (GTK_ADJUSTMENT (gtk_adjustment_new (0, 0, 360, 1, 45, 1)));
  gtk_widget_set_name (rot_slide, "rot_slide");
  gtk_widget_ref (rot_slide);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "rot_slide", rot_slide,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rot_slide);
  gtk_box_pack_start (GTK_BOX (hbox1), rot_slide, TRUE, TRUE, 0);
  gtk_scale_set_digits (GTK_SCALE (rot_slide), 0);

  dialog_action_area1 = GTK_DIALOG (sizedialog)->action_area;
  gtk_widget_set_name (dialog_action_area1, "dialog_action_area1");
  gtk_object_set_data (GTK_OBJECT (sizedialog), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  set1_ok = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (set1_ok, "set1_ok");
  gtk_widget_ref (set1_ok);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "set1_ok", set1_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set1_ok);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), set1_ok, FALSE, FALSE, 0);
  gtk_widget_set_usize (set1_ok, 80, -2);

  set1_cancel = gtk_button_new_with_label (_("CANCEL"));
  gtk_widget_set_name (set1_cancel, "set1_cancel");
  gtk_widget_ref (set1_cancel);
  gtk_object_set_data_full (GTK_OBJECT (sizedialog), "set1_cancel", set1_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (set1_cancel);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), set1_cancel, FALSE, FALSE, 0);
  gtk_widget_set_usize (set1_cancel, 80, -2);

  gtk_signal_connect (GTK_OBJECT (set1_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_set1_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (set1_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_set1_cancel_clicked),
                      NULL);

  return sizedialog;
}

GtkWidget*
create_menu1 (void)
{
  GtkWidget *menu1;
  GtkAccelGroup *menu1_accels;
  GtkWidget *loadrequest;
  GtkWidget *resizerequest;
  GtkWidget *__________1;
  GtkWidget *exit1;

  menu1 = gtk_menu_new ();
  gtk_widget_set_name (menu1, "menu1");
  gtk_object_set_data (GTK_OBJECT (menu1), "menu1", menu1);
  menu1_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menu1));

  loadrequest = gtk_menu_item_new_with_label (_("Picture Load"));
  gtk_widget_set_name (loadrequest, "loadrequest");
  gtk_widget_ref (loadrequest);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "loadrequest", loadrequest,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (loadrequest);
  gtk_container_add (GTK_CONTAINER (menu1), loadrequest);

  resizerequest = gtk_menu_item_new_with_label (_("Size & Rotation"));
  gtk_widget_set_name (resizerequest, "resizerequest");
  gtk_widget_ref (resizerequest);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "resizerequest", resizerequest,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (resizerequest);
  gtk_container_add (GTK_CONTAINER (menu1), resizerequest);

  __________1 = gtk_menu_item_new ();
  gtk_widget_set_name (__________1, "__________1");
  gtk_widget_ref (__________1);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "__________1", __________1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (__________1);
  gtk_container_add (GTK_CONTAINER (menu1), __________1);
  gtk_widget_set_sensitive (__________1, FALSE);

  exit1 = gtk_menu_item_new_with_label (_("Exit"));
  gtk_widget_set_name (exit1, "exit1");
  gtk_widget_ref (exit1);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "exit1", exit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit1);
  gtk_container_add (GTK_CONTAINER (menu1), exit1);

  gtk_signal_connect (GTK_OBJECT (loadrequest), "activate",
                      GTK_SIGNAL_FUNC (on_loadrequest_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (resizerequest), "activate",
                      GTK_SIGNAL_FUNC (on_resizerequest_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (exit1), "activate",
                      GTK_SIGNAL_FUNC (on_exit1_activate),
                      NULL);

  return menu1;
}

GtkWidget*
create_error1 (void)
{
  GtkWidget *error1;
  GtkWidget *dialog_vbox2;
  GtkWidget *errorname;
  GtkWidget *dialog_action_area2;
  GtkWidget *button1;

  error1 = gtk_dialog_new ();
  gtk_widget_set_name (error1, "error1");
  gtk_object_set_data (GTK_OBJECT (error1), "error1", error1);
  gtk_window_set_title (GTK_WINDOW (error1), _("LiMo seal Error"));
  GTK_WINDOW (error1)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (error1), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (error1), TRUE);
  gtk_window_set_policy (GTK_WINDOW (error1), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (error1)->vbox;
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_object_set_data (GTK_OBJECT (error1), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  errorname = gtk_label_new (_("Value is too big."));
  gtk_widget_set_name (errorname, "errorname");
  gtk_widget_ref (errorname);
  gtk_object_set_data_full (GTK_OBJECT (error1), "errorname", errorname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (errorname);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), errorname, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (errorname), 0.5, 1);
  gtk_misc_set_padding (GTK_MISC (errorname), 26, 14);

  dialog_action_area2 = GTK_DIALOG (error1)->action_area;
  gtk_widget_set_name (dialog_action_area2, "dialog_action_area2");
  gtk_object_set_data (GTK_OBJECT (error1), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  button1 = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (button1, "button1");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (error1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), button1, FALSE, FALSE, 0);
  gtk_widget_set_usize (button1, 64, -2);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_error1_ok),
                      NULL);

  return error1;
}

