/* =====================================================================

   LiMo - Liblary
      Graphic Manage System.  - ̼ײ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Nov.24.2000  ɥåݥ饤褦
  Nov.20.2000  ս꤫ǤĤޤ֤Ϥä
  Nov.19.2000  åȤξͥ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit          -- ʤ
  RRMain              -- ׻,
  RRMainFree          -- ᥤץཪλ()
  RRMainResize        -- ,
  RRMainSetPicture    -- 

  RRMainDragStart     -- ɥĤޤ줿
  RRMainDragEnd       -- ɥΥ줿
  RRMainDragMove      -- ɥư

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <math.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "lm_pix_rot.h"

/* --- եåǡ */
#include  "../picture/lm_penguin2.xpm"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  SMOOTH_MODE   LM_PIXROT_SMOOTH

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  rose_work1(void);
void  rose_work2(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- 饯ݻ */
static gint  cw, ch;
static gint  fw, fh;

/* --- ߤγ */
static gint  interval;
static gint  int_handle;

/* --- ǡݻ */
static GdkPixbuf  *megane = NULL;
static GdkPixmap  *disppix = NULL;
static GdkBitmap  *dispmask = NULL;

/* --- ɥɥåࡼִϢ */
static gboolean  win_move;
static gint cur_x, cur_y;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  win_move = FALSE;

  /* -- GdkRGB ν */
  gdk_rgb_init();

  /* -- ǥեȲ */
  megane = gdk_pixbuf_new_from_xpm_data((const char **)lm_penguin2_xpm);
  disppix = NULL;
  dispmask = NULL;
  cw = gdk_pixbuf_get_width(megane);
  ch = gdk_pixbuf_get_height(megane);

  /* -- ߳ */
  RRMainInterval(1000/4);
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  if (megane != NULL) gdk_pixbuf_unref(megane);
  if (disppix != NULL) gdk_pixmap_unref(disppix);
  if (dispmask != NULL) gdk_bitmap_unref(dispmask);
}


/* -------------------------------------------------------------
  RRMainInterval   -- ߻֤

   return : void
   gint n(n sec)
-------------------------------------------------------------- */
void RRMainInterval(gint n)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
  /* --- ͤݻ */
  interval = n;
}


/* -------------------------------------------------------------
  RRMainIntervalTime  -- ߻֤ɤߤ

   return : n (1/n sec)
   void
-------------------------------------------------------------- */
gint RRMainIntervalTime(void)
{
  return(interval);
}


/* -------------------------------------------------------------
  RRMainIntervalStop  -- 

   return : void
   void
-------------------------------------------------------------- */
void  RRMainIntervalStop(void)
{
  if (int_handle != 0) {
    gtk_timeout_remove(int_handle);
    int_handle = 0;
  }
}


/* -------------------------------------------------------------
  RRMainSetPicture   -- 

   return : ɤ߹ߤݤ
   gchar *filename = ɤ߹ߤե̾
-------------------------------------------------------------- */
gboolean      RRMainSetPicture(gchar *filename)
{
  GdkPixbuf *chr;
  gboolean  result;

  result = FALSE;

  /* --- ǡɤ߹ */ 
  chr = gdk_pixbuf_new_from_file(filename);
  if (chr != NULL) {
    cw = gdk_pixbuf_get_width(chr);
    ch = gdk_pixbuf_get_height(chr);
    if (megane != NULL) gdk_pixbuf_unref(megane);
    megane = gdk_pixbuf_add_alpha(chr, FALSE, 0xff, 0xff, 0xff);
    result = TRUE;
    RRMainResize(0, 1.0, 1.0);
    gdk_pixbuf_unref(chr);
  }

  return(result);
}


/* -------------------------------------------------------------
  RRMainResize      -- ,

   return : gboolean  顼ä֤
    rot = ž(0-359)
    wmag = Ψ
    hmag = Ψ
-------------------------------------------------------------- */
gboolean  RRMainResize(gint rot, gfloat wmag, gfloat hmag)
{
  GtkWidget *mainwin;
  GdkPixbuf  *step1, *step2;
  gfloat  r;

  /* --- limiter */
  rot = rot % 360;

  /* --- βä˴ */
  if (disppix != NULL) {
    gdk_pixmap_unref(disppix);
    disppix = NULL;
  }
  if (dispmask != NULL) {
    gdk_bitmap_unref(dispmask);
    dispmask = NULL;
  }

  /* --- βù */
  r = ((M_PI * 2) * rot) / 360;
  step1 = lm_pix_mag_new(megane, wmag, hmag, SMOOTH_MODE);
  step2 = lm_pix_rot_new(step1, r, 1.0, SMOOTH_MODE);

  /* --- ɽ */
  fw = gdk_pixbuf_get_width(step2);
  fh = gdk_pixbuf_get_height(step2);
  mainwin = RRScreenWindow();
  gtk_window_activate_focus(GTK_WINDOW(mainwin));
  RRScreenFree();
  gtk_widget_set_usize (mainwin, fw, fh);
  RRScreenInit(mainwin, RRGetParts(mainwin, "screen"), fw, fh, TRUE);
  gdk_pixbuf_render_pixmap_and_mask(step2, &disppix, &dispmask, 0xc0);
  RRScreenPutPixmap(disppix, 0, 0);
  RRScreenWinShape(dispmask);
  gdk_pixbuf_unref(step1);
  gdk_pixbuf_unref(step2);

  gdk_window_raise(mainwin->window);

  return(TRUE);
}



/* -------------------------------------------------------------
  RRMain     -- Ū

   return : void
    void
-------------------------------------------------------------- */
void  RRMain(void)
{
  /* --- Graphic Buffer Υå */
  if (RRScreenWindow() != NULL) {
    RRScreenSwitch();
  }
  else {
    RRScreenSwitchRoot();
  }
}


/* -------------------------------------------------------------
  RRMainDragStart     -- ɥĤޤ줿

   return : void
   void
-------------------------------------------------------------- */
void  RRMainDragStart(void)
{
  GtkWidget *mainwin;
  GdkModifierType modmask;

  win_move = TRUE;
  mainwin = RRScreenWindow();
  gdk_window_get_pointer(NULL, &cur_x, &cur_y, &modmask);
  gdk_window_raise(mainwin->window);
}

/* -------------------------------------------------------------
  RRMainDragEnd       -- ɥΥ줿

   return : void
   void
-------------------------------------------------------------- */
void  RRMainDragEnd(void)
{
  GdkModifierType modmask;

  win_move = FALSE;
  gdk_window_get_pointer(NULL, &cur_x, &cur_y, &modmask);
}

/* -------------------------------------------------------------
  RRMainDragMove      -- ɥư

   return : void
   void
-------------------------------------------------------------- */
void  RRMainDragMove(void)
{
  gint  dx, dy, wx, wy;
  GdkModifierType modmask;

  if (win_move == TRUE) {
    dx = cur_x;
    dy = cur_y;
    gdk_window_get_pointer(NULL, &cur_x, &cur_y, &modmask);
    dx -= cur_x;
    dy -= cur_y;
    gdk_window_get_origin((GdkWindow*)RRScreenWindow()->window, &wx, &wy);
    wx -= dx;
    wy -= dy;
    gdk_window_move((GdkWindow*)RRScreenWindow()->window, wx, wy);
  }
}





